<template>
  <section>
    <h2>2ème pilier</h2>
    <p>Le 2ème pilier est la prévoyance professionnelle, qui doit permettre aux assurés de maintenir leur niveau de vie antérieur. Il concerne les employés dont les revenus sont supérieurs à 21510 CHF (limite 2021). Le taux de cotisation varie selon l'institution de prévoyance concernée, l'employeur étant obligé de verser au moins la moitié de la cotisation.</p>
    <div class="two-columns">
      <div class="two-columns--item">
        <p>Ici nous allons:</p>
        <ol class="info-nav">
          <li :class="{'info-strong': state == 0}">Demander à l’utilisateur de choisir sa caisse de pension</li>
          <li :class="{'info-strong': state == 1}">Enregistrer sa sélection</li>
          <li :class="{'info-strong': state == 2}">Connecter l’utilisateur au système de sa caisse de pension</li>
          <li :class="{'info-strong': state == 3}">Récupérer les rentes de la prévoyance professionnelle (2ème pilier)</li>
        </ol>
        <NuxtLink class="button--strong" tag="button" to="/open3k" v-if="state == 4">Continuer ➜</NuxtLink>
      </div>
      <div class="two-columns--item">
        <loading :active.sync="isLoading" :is-full-page="fullPage" />
        <template v-if="registry">
          <h3>Vos caisses de prévoyance</h3>
          <multiselect
          v-model="selection"
          :options="Object.values(registry)"
          :multiple="true"
          track-by="id"
          label="name"
          :preserve-search="true"
          placeholder="1. Recherchez par le nom"
          />

          <template v-if="selection.length > 0">
            <br>
            <button v-if="JSON.stringify(currentSelected) != JSON.stringify(selection)" @click="saveSelection">
              2. Sauvegarder votre sélection
            </button>

            <template v-if="JSON.stringify(currentSelected) == JSON.stringify(selection)">
              <template v-if="!policies">
                <button v-if="!grantingOk" @click="startGranting">
                  3. Donner accès à vos données à l'application
                </button>

                <button v-if="grantingOk" @click="getFunds">
                  4. Récupérer les informations des pensions
                </button>
              </template>
              <template v-else>
                <ul>
                  <li v-for="(policy, policyId) in policies" :id="policyId+openPolicies[policyId]" :key="policyId+openPolicies[policyId]">
                    <h4>{{ registry[policyId].name }}</h4>
                    <a @click="$set(openPolicies, policyId, !openPolicies[policyId])">Toggle policy</a>
                    <template v-if="openPolicies[policyId]">
                      <pre>{{ policy }}</pre>
                    </template>
                  </li>
                </ul>
              </template>
            </template>
          </template>
        </template>
      </div>
    </div>
  </section>
</template>

<script>

  import Loading from 'vue-loading-overlay'
  import { mapMutations } from 'vuex'
  import Multiselect from 'vue-multiselect'

  export default {
    components: {
      Loading,
      Multiselect
    },
    data () {
      return {
        fullPage: false,
        isLoading: true,
        selection: [],
        userSelectedFundIds: [],
        currentSelected: [],
        grantingWindow: null,
        grantingOk: false,
        policies: null,
        openPolicies: {}
      }
    },
    computed: {
      state() {
        if (this.isLoading && (this.selection.length < 1)) return -1;
        if (this.selection.length < 1) return 0;
        if (JSON.stringify(this.currentSelected) != JSON.stringify(this.selection)) return 1;
        if (!this.policies && !this.grantingOk) return 2;
        if (!this.policies && this.grantingOk) return 3;

        return 4;
      },
      registry () {
        return this.$store.state.openpk.registry
      },
      fundSelection () {
        return this.$store.state.user.fundSelection
      }
    },
    mounted () {
      this.$nuxt.$emit('check-if-connected')
      this.$nuxt.$once('user-is-connected', this.init)
    },
    methods: {
      ...mapMutations({
        setPolicies: 'openpk/setPolicies',
        setRegistry: 'openpk/setRegistry',
        setFundSelection: 'user/setFunds'
      }),
      init () {
        window.addEventListener('message', (msg) => {
          if (!this.grantingWindow) {
            return
          }
          const data = msg.data
          if (data === 'grant-is-okay') {
            this.grantingWindow.close()
            this.grantingWindow = null
            this.grantingOk = true
            this.getFunds();
          }
        }, false)

        if (!this.registry) {
          this._getRegistry().then((data) => {
            this.setRegistry(data)
            this.checkSelection()
          })
        }

        this._getSelection().then((data) => {
          this.userSelectedFundIds = data || []
          this.setFundSelection(this.userSelectedFundIds)
          this.checkSelection()
        })
      },
      checkSelection () {
        if (!this.userSelectedFundIds || !this.registry) {
          return
        }
      // ['id', 'name'].reduce((result, key) => { result[key] = user[key]; return result; }, {});
        this.selection = Object.values(this.userSelectedFundIds.reduce((result, key) => { result[key] = this.registry[key]; return result }, {}))
        this.currentSelected = Object.values(this.userSelectedFundIds.reduce((result, key) => { result[key] = this.registry[key]; return result }, {}))

        this.isLoading = false
      },
      saveSelection () {
        this.policies = null
        this.grantingOk = false
        this.isLoading = true
        const selection = this.selection.map(x => x.id)

        this._saveSelection(selection).then(() => {
          this._getSelection().then((selection) => {
            this.currentSelected = Object.values(selection.reduce((result, key) => {
              result[key] = this.registry[key]
              return result
            }, {}))
            this.currentSelected.sort((a, b) => {
              if (selection.indexOf(a.id) > selection.indexOf(b.id)) { return 1 }
                if (selection.indexOf(a.id) < selection.indexOf(b.id)) { return -1 }
                  return 0
              })
            this.setFundSelection(selection)
            this.isLoading = false
          })
        })
      },
      startGranting () {
        const strWindowFeatures = 'menubar=no,location=yes,resizable=yes,scrollbars=yes,status=yes,height=700, width=800'

        // this.grantingWindow = window.open(this.$config.dibsApiBasePath + '/openpk/user/pension-funds/tokens', 'GRANTING_WINDOW', strWindowFeatures)
        this.grantingWindow = window.open(this.$config.dibsApiBasePath + '/openpk/user/pension-funds/tokens', '_blank')
      },
      getFunds () {
        this.isLoading = true
        this._getPolicies().then((policies) => {
          this.setPolicies(policies);
          this.policies = policies
          this.isLoading = false
        })
      },
      _getPolicies () {
        return this.$api.get('/openpk/user/pension-funds/policies')
      },
      _getSelection () {
        return this.$api.get('/openpk/user/pension-funds')
      },
      _saveSelection (selection) {
        return this.$api.post('/openpk/user/pension-funds', {
          ids: selection
        })
      },
      _getRegistry () {
        return this.$api.get('/openpk/pension-funds')
      }
    }
  }
</script>
<style>
  .multiselect__input, .multiselect__single {
    border: none !important;
  }
</style>
